﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package at.ssw.jku.view;

import at.ssw.jku.model.Segment;
import javafx.scene.Parent;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;

public final class SegmentNode extends Parent {
  private final Segment segment;

  public SegmentNode(final Segment segment, final CoordinateConverter converter) {
    this.segment = segment;

    final Rectangle rect = new Rectangle(
        converter.modelToScreenX(segment.getX()),
        converter.modelToScreenY(segment.getY()),
        converter.modelToScreenWidth(1),
        converter.modelToScreenHeight(1));
    
    rect.setFill(Color.BLUE);
    
    getChildren().add(rect);
  }

  @Override
  public String toString() {
    return String.format("<seg: %s>", segment);
  }
}
