﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
package at.ssw.jku.view;

import java.util.List;

import javafx.collections.ListChangeListener;
import javafx.scene.Parent;
import at.ssw.jku.model.Segment;
import at.ssw.jku.model.Worm;

public final class WormNode extends Parent {
  public WormNode(final Worm worm, final CoordinateConverter converter) {
    setChildrenFrom(worm, converter);

    worm.getSegments().addListener(new ListChangeListener<Segment>() {
      @Override
      public void onChanged(Change<? extends Segment> change) {
        setChildrenFrom(worm, converter);
      }
    });
  }
  
  private void setChildrenFrom(Worm worm, CoordinateConverter converter) {
    getChildren().setAll(createSegmentNodes(worm.getSegments(), converter));
  }

  private SegmentNode[] createSegmentNodes(List<? extends Segment> forSegments, CoordinateConverter converter) {
    SegmentNode[] segmentNodes = new SegmentNode[forSegments.size()];
    for (int i = 0; i < segmentNodes.length; ++i) {
      segmentNodes[i] = new SegmentNode(forSegments.get(i), converter);
    }
    return segmentNodes;
  }
}
